<template>
  <AppModal
    name-modal="modal-abuse"
    :width-modal="500"
    :visible="visible"
    @before-close="$emit('before-close')"
    init-class="modalAbuse">
    <template #header>
      <div class="heading">
        Пожаловаться на продавца {{ sellerTitle }}
      </div>
    </template>

    <template slot="body">
      <form
        v-if="!isSuccess"
        id="abuse"
        @submit.prevent="onSubmit">
        <div class="input">
          <textarea
            class="input-field"
            cols="30"
            rows="10"
            placeholder="Ваша жалоба"
            v-model="abuseContent"/>
        </div>
        <AppButton
          :type="'submit'"
          :disabled="!abuseContent"
          form="abuse">
          <span
            slot="button-item"
            class="button-item">
            Отправить жалобу
          </span>
        </AppButton>
      </form>
      <div
        class="_success"
        v-show="isSuccess">
        <img
          svg-inline
          src="~/assets/svg/redesign/ok-big.svg">
        <div class="heading">Спасибо за ваше обращение, жалоба будет рассмотрена в течение рабочего дня.</div>
      </div>
    </template>
  </AppModal>
</template>

<script>
import AppModal from '~/components/redesign/app-modals/app-modal';
import AppButton from '~/components/redesign/app-buttons/app-button';
import Modals from '~/assets/js/mixins/redesign/modals';

export default {
  name: 'AppModalAbuse',
  components: {
    AppModal,
    AppButton,
  },
  mixins: [Modals],
  props: {
    shopId: {
      type: Number,
      default: null,
    },
    sellerTitle: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      abuseContent: '',
      isSuccess: false,
    };
  },
  methods: {
    async onSubmit() {
      try {
        await this.$axios.$post('/_main/abuse/create', {
          shopId: this.shopId,
          comment: this.abuseContent,
        });
        this.$ym('abuse_sent');
        this.isSuccess = true;
        this.abuseContent = '';
      } catch (e) {
        console.error(e);
      }
    },
  },
};
</script>

<style lang="postcss">
.modalAbuse {
  .appModal-header {
    flex-shrink: 1;
    text-align: center;

    .heading {
      width: 100%;
    }
  }

  .appModal-body {
    padding: 1.25rem 3rem 2.5rem;
    background-color: var(--bg-lighten);
    .input-field {
      resize: none;
    }
    .button {
      display: flex;
      margin: 1.5rem auto 0;
      height: var(--btn-height-huge);
    }

    ._success {
      display: flex;
      flex-direction: row;
      justify-content: center;
      align-items: center;

      & .svg {
        margin-right: 2rem;
      }
    }
  }


  @media screen and (max-width: 980px) {
    top: 0!important;
    left: 0!important;
    right: 0;
    margin: 0 auto;
    min-height: 100vh;

    .appModal-header {
      height: auto;

      .heading {
        font-size: 1.375rem;
      }
    }
    .appModal-body {
      padding: 1.5rem 1rem 5rem;
      height: 100vh;
      max-height: calc(100vh - 4.375rem);
      background-color: var(--bg-main);
      .input-field {
        min-height: 14rem;
        height: 50vh;
      }
      .button {
        width: 100%;
      }
    }
  }
}
</style>
